/***********************************************************/
/*                                                         */
/* AccMapRenderer.h                                        */
/*                                                         */
/* created 24.05.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef ACCMAPRENDERER_H
#define ACCMAPRENDERER_H

#include "D3DStruct.h"
#include "TerrainInterface.h"
#include "TerrainLineRenderer.h"

// www.infinitecode.com 3d library
namespace I3D
{

// Accessibility Map Renderer
class AccMapRenderer
{
public:
	class AMRSpecs
	{
	public:
		D3DStruct *DS;
		TerrainInterface *TI;
		TerrainLineRenderer *TLR;
	};

private:
	AMRSpecs Specs;
	TerrainLine *Lines;

	void AccMapRenderer::CreateLines();

public:
	AccMapRenderer(void);
	~AccMapRenderer(void);

	void Create(AMRSpecs *Specs);
	void Render(D3DStruct *DS);
	void Destroy();
};

}

#endif
