/***********************************************************/
/*                                                         */
/* Button.h                                                */
/*                                                         */
/* created 01.03.2004                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef BUTTON_H
#define BUTTON_H

#include "Renderable.h"
#include "D3DStruct.h"
#include "MathStructures.h"

// www.infinitecode.com 3d library
namespace I3D
{

class Button: public RenderableIndex
{
public:
	class Specs
	{
	public:
		Specs(): Texture(0), TilesX(8), TilesY(8), Index(0)
		{
			*Text = 0;
		}

		D3DStruct *DS;
		int TilesX, TilesY;
		int Index;
		IMATH::Vector2D Pos, Size;
		LPDIRECT3DTEXTURE9 Texture;
		char Text[1024];
	};

private:
	Specs Sp;

public:
	void Create(const Button::Specs &Sp);
	void Init3D(D3DStruct *DS, bool recurse);
	virtual void Render(D3DStruct *DS);
	virtual void CreateView(D3DStruct *DS) {};
	bool Click(const IMATH::Vector2D &Pos);
};

}

#endif
