/***********************************************************/
/*                                                         */
/* ClientSocket.h                                          */
/*                                                         */
/* created 03.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef CLIENTSOCKET_H
#define CLIENTSOCKET_H

#include "TCPSocket.h"

// www.infinitecode.com Network Library
namespace INETW
{

DWORD WINAPI CSThreadProcedure(void *Parameter);

#define CLIENTSOCKET_BUFSIZE 16384

class ClientSocket: public TCPSocket
{
	HANDLE ThreadHandle;
	unsigned long ThreadId;
	bool ThreadRunning;
	char NBBuf[CLIENTSOCKET_BUFSIZE];
	int Available;

	friend DWORD WINAPI CSThreadProcedure(void *Parameter);

	bool Create(char *Server, int Port, bool Blocking = true);

public:
	ClientSocket(char *Server, int Port, bool Blocking = true);
	ClientSocket(int Sck, bool Blocking = true);
	~ClientSocket(void);

	virtual void Destroy(void);

	int Recv(char *Buf, int Len);
	int RecvPeek(char *Buf);
	int Send(char *Buf, int Len);
};

}

#endif
