/***********************************************************/
/*                                                         */
/* Credits.cpp                                             */
/*                                                         */
/* created 13.04.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Credits.h"
#include "Text.h"

#include <fstream>

// www.infinitecode.com 3d library
namespace I3D
{

Credits::~Credits()
{
	if(Text)
	{
		delete Text;
		Text = 0;
	}
}

void Credits::Create(const char *Filename)
{
	Scroll = 0;
	std::ifstream f(Filename, std::ios::binary);
	f.seekg(0, std::ios::end);
	int FileLength = f.tellg();
	f.seekg(0, std::ios::beg);
	if(!Text)
		delete Text;
	Text = new char[FileLength + 1];
	f.read(Text, FileLength);
	Text[FileLength] = 0;
	f.close();
	Lines = 0;
	char *Txt = Text;
	while(*Txt)
	{
		if(*Txt == '\n')
			Lines++;
		Txt++;
	}
}

void Credits::Render(I3D::D3DStruct *DS)
{
	const float LineSpacing = 0.5f;
	Scroll += 0.2f * DS->Sp->Delta;
	if(Scroll > 2.0f + Lines * (1 + LineSpacing) * 0.05f)
		Scroll = 0;
	I3D::Text::DrawString(DS, Credits::Text, -0.9f, -1.0f + Scroll, 0.05f, 0.05f, LineSpacing);
}

}
