/***********************************************************/
/*                                                         */
/* DSSound.h                                               */
/*                                                         */
/* created 08.05.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef	DSSOUND_H
#define DSSOUND_H

#include <dsound.h>

#ifndef RELEASE
	#define RELEASE(x) if(x){(x)->Release();}
#endif

#include <fstream>
using namespace std;

// www.infinitecode.com audio library
namespace IAU
{

class DSSound
{
	LPDIRECTSOUNDBUFFER *Buffers;
	char Filename[1024];
	int MaxInstances, CurrentBuffer;
	bool Valid;

	void CheckEof(ifstream *f, const char *Filename);

public:
	DSSound(void): Buffers(0), Valid(false) {}
	~DSSound(void);

	const char *GetFilename(void)
	{
		return Filename;
	}

	void Create(LPDIRECTSOUND8 DS, const char *Filename, int MaxInstances = 1);
	void Destroy(void);
	void Play(float Direction = 0);
};

}

#endif
