/***********************************************************/
/*                                                         */
/* DebugPos.h                                              */
/*                                                         */
/* created 19.09.2004                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef DEBUGPOS_H
#define DEBUGPOS_H

#include "MathStructures.h"
#include "DynamicArray.h"

class DebugPos
{
public:
	typedef ISL::DynamicArray<IMATH::Vector2DXZ> ArrayType;

private:
	static ArrayType Positions;

	// singleton
	DebugPos() {}
	DebugPos(DebugPos &) {}
	DebugPos &operator = (DebugPos &) {}
public:

	static void Add2DXZ(IMATH::Vector2DXZ Pos)
	{
		Positions.Add(Pos);
	}

	static ArrayType &GetPosArray()
	{
		return Positions;
	}

	static void Clear()
	{
		Positions.Clear();
	}
};

#endif
