/***********************************************************/
/*                                                         */
/* DecalLib.cpp                                         */
/*                                                         */
/* created 11.01.2004                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "DecalLib.h"
#include "D3DStruct.h"
#include <stdio.h>

// www.infinitecode.com game library
namespace IGAME
{

void DecalLib::Create(void)
{
	ITL::IniLoader DecalData;

	DecalData = ITL::IniLoader("Libs\\Decals.ini");
	for(int i = 0; i < DecalData.CountGroups(); i++)
	{
		Decal Dec;
		for(int j = 0; j < DecalData.CountKeys(i); j++)
		{
			const char *Key = DecalData.GetKey(i, j);
			const char *Value = DecalData.GetValue(i, j);
			// int
			if(!stricmp(Key, "ID"))
				Dec.ID = atoi(Value);
			// float
			if(!stricmp(Key, "Bounds1X"))
				Dec.Bounds[0].x = (float)atof(Value);
			if(!stricmp(Key, "Bounds1Z"))
				Dec.Bounds[0].z = (float)atof(Value);
			if(!stricmp(Key, "Bounds2X"))
				Dec.Bounds[1].x = (float)atof(Value);
			if(!stricmp(Key, "Bounds2Z"))
				Dec.Bounds[1].z = (float)atof(Value);
			if(!stricmp(Key, "Bounds3X"))
				Dec.Bounds[2].x = (float)atof(Value);
			if(!stricmp(Key, "Bounds3Z"))
				Dec.Bounds[2].z = (float)atof(Value);
			if(!stricmp(Key, "Bounds4X"))
				Dec.Bounds[3].x = (float)atof(Value);
			if(!stricmp(Key, "Bounds4Z"))
				Dec.Bounds[3].z = (float)atof(Value);
			if(!stricmp(Key, "CenterX"))
				Dec.Center.x = (float)atof(Value);
			if(!stricmp(Key, "CenterZ"))
				Dec.Center.z = (float)atof(Value);
			// string
			if(!stricmp(Key, "Texture"))
				strcpy(Dec.Texture, Value);
			if(!stricmp(Key, "Name"))
				strcpy(Dec.Name, Value);
		}
		Decals.Add(Dec);
	}
}

}
