/***********************************************************/
/*                                                         */
/* DecalLib.h                                              */
/*                                                         */
/* created 11.01.2004                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef DECALLIB_H
#define DECALLIB_H

#include "IniLoader.h"
#include "DynamicArray.h"
#include "MathStructures.h"

// www.infinitecode.com game library
namespace IGAME
{

class DecalLib
{
public:
	#define DLIB_STRMEM 1024

	class Decal
	{
	public:
		Decal(void)
		{
			*Texture = 0;
			*Name = 0;
			Bounds[0] = IMATH::Vector2DXZ(-128, -128);
			Bounds[1] = IMATH::Vector2DXZ( 128, -128);
			Bounds[2] = IMATH::Vector2DXZ(-128,  128);
			Bounds[3] = IMATH::Vector2DXZ( 128,  128);
		}

		IMATH::Vector2DXZ Bounds[4], Center;
		char Texture[1024], Name[1024];
		int ID;
	};

	ISL::DynamicArray<Decal, 0, 1> Decals;

	void Create(void);
};

}

#endif
