/***********************************************************/
/*                                                         */
/* EventSender.h                                           */
/*                                                         */
/* created 19.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef EVENTSENDER_H
#define EVENTSENDER_H

#include "DynamicArray.h"
#include "EventListener.h"

// www.infinitecode.com event library
namespace IEV
{

template <class EvtType>
class EventListener;

template <class EvtType>
class EventSender
{
	ISL::DynamicArray<EventListener<EvtType> *, 0, 1> Listener;

protected:
	void SendEvent(EvtType Event)
	{
		for(int i = 0; i < Listener.Count(); i++)
		{
			Listener[i]->OnEvent(Event);
		}
	}

public:

/*	~EventSender(void)
	{
		for(int i = 0; i < Listener.Count(); i++)
		{
			Listener[i] = 0;
		}
	}*/

	void AddListener(EventListener<EvtType> *Listener)
	{
		EventSender::Listener[EventSender::Listener.Count()] = Listener;
	}

	void DeleteListener(EventListener<EvtType> *Listener)
	{
		EventSender::Listener.Delete(Listener);
	}

};

}

#endif
