/***********************************************************/
/*                                                         */
/* Fader.cpp                                               */
/*                                                         */
/* created 06.07.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Fader.h"

#include "RenderStruct.h"

// www.infinitecode.com 3d library
namespace I3D
{

	void Fader::Fade(I3D::D3DStruct *DS, float Opacity)
	{
		Matrix Mtx, WMtx;
		Mtx.SetIdentityMatrix();
		DS->D3DDevice->SetTransform(D3DTS_WORLD, &Mtx);
		DS->D3DDevice->SetTransform(D3DTS_VIEW, &Mtx);
		DS->D3DDevice->SetTransform(D3DTS_PROJECTION, &Mtx);
		DS->D3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		DS->D3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		DS->D3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
		DS->D3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);

		char Alpha = (int)(0xFF * Opacity);
		unsigned Color = Alpha << 24;
		//unsigned Color = 0xFFFFFFFF;
		RenderStruct<LVertex, I3D_FVFLVERTEX, 4, 4> RS;
		RS.AddVertex(LVertex(Vector(-1.0f,  1.0f, 0), Color, Vector2D(0, 0)));
		RS.AddVertex(LVertex(Vector(-1.0f, -1.0f, 0), Color, Vector2D(0, 1)));
		RS.AddVertex(LVertex(Vector( 1.0f,  1.0f, 0), Color, Vector2D(1, 0)));
		RS.AddVertex(LVertex(Vector( 1.0f,  1.0f, 0), Color, Vector2D(1, 0)));
		RS.AddVertex(LVertex(Vector(-1.0f, -1.0f, 0), Color, Vector2D(0, 1)));
		RS.AddVertex(LVertex(Vector( 1.0f,  -1.0f, 0), Color, Vector2D(1, 1)));
		RS.CreateVBuf(DS->D3DDevice);

		DS->D3DDevice->SetTexture(0, 0);
		RS.RenderVertex(DS->D3DDevice, 0, 6);

		DS->D3DDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
		DS->D3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
		DS->D3DDevice->SetTransform(D3DTS_VIEW, &DS->ProjMtx);
		DS->D3DDevice->SetTransform(D3DTS_PROJECTION, &DS->ViewMtx);
	}

}
