/***********************************************************/
/*                                                         */
/* ForceFeedbackInterface.h                                */
/*                                                         */
/* created 17.10.2005                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

// Interface Class for Space Managers like bsptrees, quadtrees
// and octrees

#ifndef FORCEFEEDBACKINTERFACE_H
#define FORCEFEEDBACKINTERFACE_H

// www.infinitecode.com 3d library
namespace I3D
{

class ForceFeedbackInterface
{
public:
	virtual void SetShakeVector(const IMATH::Vector &Shake) = 0;
	virtual void AddShakeVector(const IMATH::Vector &Position, const IMATH::Vector &Shake) = 0;
};

}

#endif
