/***********************************************************/
/*                                                         */
/* ISLString.h                                             */
/*                                                         */
/* created 07.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef ISLSTRING_H
#define ISLSTRING_H

#include <string.h>

// www.infinitecode.com Standard Data Structure Library
namespace ISL
{

class String
{
	char *Str;

	void ReAlloc(int Size);

public:
	String(const char *Str);
	String(void);
	~String(void);

	int Length(void);
	const char *GetChars(void);
	bool Replace(char *Str, char *Rep);

	// copy functions
	String(String& DA)
	{
		*this = DA;
	}

	String& operator=(String& Str2)
	{
		if(Str) delete[] Str;
		Str = new char[Str2.Length() + 1];
		strcpy(Str, Str2.Str);
		return *this;
	}

	String& operator+(String& Str2)
	{
		String Ret = *this;
		Ret.ReAlloc(Length() + Str2.Length() + 1);
		for(int i = 0; i < Str2.Length() + 1; i++)
			Str[Length() + i] = Str2.Str[i];
		return *this;
	}

	bool operator==(String& Str2)
	{
		return !strcmpi(Str, Str2.Str);
	}
};

}

#endif
