/***********************************************************/
/*                                                         */
/* Input.h                                                 */
/*                                                         */
/* created 19.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef INPUT_H
#define INPUT_H

#include "DynamicArray.h"

#include <windows.h>
#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

// www.infinitecode.com input library
namespace IIN
{

#ifndef RELEASE
	#define RELEASE(x) if(x){(x)->Release();}
#endif

enum
{
	INPUT_DOWN =	0,
	INPUT_UP =		1
};

class Input
{
public:
	class MouseEvent
	{
	public:
		int Button, Code;
		int x, y;
	};

private:
	LPDIRECTINPUTDEVICE8 DIDevice;
	LPDIRECTINPUT8 DI;

	POINT Pos;
	int Wheel, WheelOrigin;
	ISL::DynamicArray<MouseEvent, 0, 1> Events;

public:
	Input(): DI(0), DIDevice(0) {}
	~Input(void);

	void Create(HWND Wnd);
	void Update(void);
	bool GetEvent(MouseEvent *Event);

	const POINT &GetPos(void)
	{
		return Pos;
	}

	int GetZ(void)
	{
		return Wheel;
	}

};

}

#endif
