/***********************************************************/
/*                                                         */
/* MEditor.cpp                                             */
/*                                                         */
/* created 23.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "ModelEditor.h"

// www.infinitecode.com 3d library
namespace IGAME
{

	ModelEditor Editor;

}

int WINAPI WinMain(HINSTANCE ThisInstance, HINSTANCE PrevInstance, LPSTR Argument, int WindowStyle)
{
	try
	{
		IGAME::Editor.Create(ThisInstance, WindowStyle);
		bool Quit = false;
		MSG Msg;
		// main message handling loop
		while ( !Quit )
		{
			if ( PeekMessage( &Msg, NULL, 0, 0, PM_REMOVE ) )
			{
				if ( Msg.message == WM_QUIT )
				{
					Quit=TRUE;
				}
				else
				{
					TranslateMessage( &Msg );
					DispatchMessage( &Msg );
				}
			}
			else
			{
				// Game main loop function
				IGAME::Editor.MainLoop();
			}
		}
	}
	catch(std::exception& Ex)
	{
		// exceptions
		char Str[1024];
		strcpy(Str, "Unhandled Exception: ");
		strcat(Str, (char *)Ex.what());
		strcat(Str, "\r\n\r\n");
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(char *Ex)
	{
		// char * exceptions
		char Str[1024];
		strcpy(Str, "Unhandled Exception (char *): ");
		strcat(Str, Ex);
		strcat(Str, "\r\n\r\n");
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(int Ex)
	{
		// int exceptions
		char Str[1024], Buf[1024];
		strcpy(Str, "Unhandled Exception (int): ");
		strcat(Str, itoa(Ex, Buf, 10));
		strcat(Str, "\r\n\r\n");
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(...)
	{
		// unknown exceptions
		char Str[1024];
		strcpy(Str, "Unhandled Unknown Exception");
		strcat(Str, "\r\n\r\n");
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}	return 0;
}
