/***********************************************************/
/*                                                         */
/* MathStructures.cpp                                      */
/*                                                         */
/* created 24.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "MathStructures.h"

// www.infinitecode.com math library
namespace IMATH
{

Vector operator * (float Scalar, const Vector &V)
{
	return Vector(Scalar * V.x, Scalar * V.y, Scalar * V.z);
}

Vector2D operator * (float Scalar, const Vector2D &V)
{
	return Vector2D(Scalar * V.x, Scalar * V.y);
}

Vector2DXZ operator * (float Scalar, const Vector2DXZ &V)
{
	return Vector2DXZ(Scalar * V.x, Scalar * V.z);
}

}

/*IMATH::Vector operator * (float Scalar, IMATH::Vector& V)
{
	return IMATH::Vector(Scalar * V.x, Scalar * V.y, Scalar * V.z);
}

IMATH::Vector2DXZ operator * (float Scalar, const IMATH::Vector2DXZ& V)
{
	return IMATH::Vector2DXZ(Scalar * V.x, Scalar * V.z);
}
*/