/***********************************************************/
/*                                                         */
/* ParticleFXLib.cpp                                       */
/*                                                         */
/* created 19.02.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "ParticleFXLib.h"
#include "D3DStruct.h"
#include <stdio.h>

// www.infinitecode.com 3d library
namespace I3D
{

void ParticleFXLib::Create(void)
{
	ITL::IniLoader PFXData;

	PFXData = ITL::IniLoader("Libs\\ParticleEffects.ini");
	for(int i = 0; i < PFXData.CountGroups(); i++)
	{
		Effect Eff;
		for(int j = 0; j < PFXData.CountKeys(i);j++)
		{
			const char *Key = PFXData.GetKey(i, j);
			// ID
			if(!stricmp(Key, "ID"))
				Eff.ID = atoi(PFXData.GetValue(i, j));
			// XFrames
			if(!stricmp(Key, "XFrames"))
				Eff.XFrames = atoi(PFXData.GetValue(i, j));
			// YFrames
			if(!stricmp(Key, "YFrames"))
				Eff.YFrames = atoi(PFXData.GetValue(i, j));
			// LightFunction
			if(!stricmp(Key, "LightFunction"))
				Eff.LightFunction = atoi(PFXData.GetValue(i, j));
			// SizeFunction
			if(!stricmp(Key, "SizeFunction"))
				Eff.SizeFunction = atoi(PFXData.GetValue(i, j));
			// LifeTime
			if(!stricmp(Key, "LifeTime"))
				Eff.LifeTime = (float)atof(PFXData.GetValue(i, j));
			// Size
			if(!stricmp(Key, "Size"))
				Eff.Size = (float)atof(PFXData.GetValue(i, j));
			// RandomizeOffset
			if(!stricmp(Key, "RandomizeOffset"))
				Eff.RandomizeOffset = strcmp(PFXData.GetValue(i, j), "true") ? false : true;
			// Texture
			if(!stricmp(Key, "Texture"))
			{
				char FName[1024], *FNPtr;
				strcpy(FName, PFXData.GetValue(i, j));
				FNPtr = FName;
				if(*FName == '\"')
					FNPtr++;
				if(FName[strlen(FName) - 1] == '\"')
					FName[strlen(FName) - 1] = 0;
				sprintf(Eff.Texture, "Textures\\%s", FNPtr);
			}
			if(!stricmp(Key, "MovementX"))
				Eff.Movement.x = (float)atof(PFXData.GetValue(i, j));
			if(!stricmp(Key, "MovementY"))
				Eff.Movement.y = (float)atof(PFXData.GetValue(i, j));
			if(!stricmp(Key, "MovementZ"))
				Eff.Movement.z = (float)atof(PFXData.GetValue(i, j));
			if(!stricmp(Key, "Rotation"))
				Eff.Rotation = (float)atof(PFXData.GetValue(i, j));
			if(!stricmp(Key, "RotationDirRandom"))
				Eff.RotationDirRandom = !stricmp(PFXData.GetValue(i, j), "true");
			if(!stricmp(Key, "RotationStartRandom"))
				Eff.RotationStartRandom = !stricmp(PFXData.GetValue(i, j), "true");
			if(!stricmp(Key, "Shake"))
				Eff.Shake = (float)atof(PFXData.GetValue(i, j));
		}
		Effects[Eff.ID] = Eff;
	}
}

}
