/***********************************************************/
/*                                                         */
/* ParticleFXLib.h                                         */
/*                                                         */
/* created 28.02.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef PARTICLEFXLIB_H
#define PARTICLEFXLIB_H

#include "IniLoader.h"
#include "D3DStruct.h"
#include "DynamicArray.h"

// www.infinitecode.com 3d library
namespace I3D
{

class ParticleFXLib
{
public:
	#define PFXL_STRMEM 1024

	class Effect
	{
	public:
		Effect(void): TextureID(0), XFrames(1), YFrames(1), LightFunction(0)
			,SizeFunction(0), LifeTime(1.0f), Size(1), RandomizeOffset(false)
			, Movement(0, 0, 0), Rotation(0), RotationDirRandom(false), RotationStartRandom(false), Shake(0)
		{
			*Texture = 0;
		}

		char Texture[PFXL_STRMEM];
		int ID, TextureID, XFrames, YFrames, LightFunction, SizeFunction;
		float LifeTime, Size, Rotation, Shake;
		bool RandomizeOffset, RotationDirRandom, RotationStartRandom;
		IMATH::Vector Movement;
	};

	ISL::DynamicArray<Effect, 0, 1> Effects;

	void Create(void);

};

}

#endif
