/***********************************************************/
/*                                                         */
/* Path.cpp                                                */
/*                                                         */
/* created 17.06.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Path.h"

namespace I3D
{

void Path::Add(IMATH::Vector2DXZ *Waypoint)
{
	Waypoints.Add(Waypoint);
}

void Path::Clear(void)
{
	Waypoints.ClearPtrElements();
}

IMATH::Vector2DXZ Path::GetWaypoint(int Index)
{
	if(Index >= Waypoints.Count())
		Index = Waypoints.Count() - 1;
	return *Waypoints[Index];
}

int Path::CountWaypoints(void)
{
	return Waypoints.Count();
}

Path::~Path(void)
{
	Waypoints.ClearPtr();
}

}
