/***********************************************************/
/*                                                         */
/* Path.h                                                  */
/*                                                         */
/* created 17.06.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef PATH_H
#define PATH_H

#include "MathStructures.h"
#include "DynamicArray.h"

// www.infinitecode.com 3d library
namespace I3D
{

class Path
{
	ISL::DynamicArray<IMATH::Vector2DXZ *> Waypoints;

public:
	~Path(void);

	void Add(IMATH::Vector2DXZ *Waypoint);
	void Clear(void);
	IMATH::Vector2DXZ GetWaypoint(int Index);
	int CountWaypoints(void);
};

}

#endif
