/***********************************************************/
/*                                                         */
/* PrefixException.cpp                                     */
/*                                                         */
/* created 08.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "PrefixException.h"

#include <string.h>

// www.infinitecode.com exception library
namespace IEX
{

PrefixException::PrefixException(char *Description)
{
	PrefixException::Prefix = new char[1];
	PrefixException::Description = new char[strlen(Description) + 1];
	strcpy(PrefixException::Prefix, "");
	strcpy(PrefixException::Description, Description);
	// combine
	Both = new char[strlen(PrefixException::Prefix) + 1 + strlen(Description)];
	strcpy(Both, PrefixException::Prefix);
	strcat(Both, Description);
}

void PrefixException::AddPrefix(char *Prefix)
{
	char *OldPref = PrefixException::Prefix;
	PrefixException::Prefix = new char[strlen(PrefixException::Prefix) + 1 + strlen(Prefix)];
	strcpy(PrefixException::Prefix, OldPref);
	strcat(PrefixException::Prefix, Prefix);
	delete[] OldPref;
	// combine
	delete[] Both;
	Both = new char[strlen(PrefixException::Prefix) + 1 + strlen(Description)];
	strcpy(Both, PrefixException::Prefix);
	strcat(Both, Description);
}

PrefixException::~PrefixException(void)
{
	delete[] Prefix;
	delete[] Description;
	delete[] Both;
}

const char *PrefixException::what(void) const
{
	return Both;
}

}
