/***********************************************************/
/*                                                         */
/* ProjectileLib.cpp                                       */
/*                                                         */
/* created 04.03.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "ProjectileLib.h"
#include "D3DStruct.h"
#include <stdio.h>

// www.infinitecode.com game library
namespace IGAME
{

void ProjectileLib::Create(void)
{
	ITL::IniLoader ProjectileData;

	ProjectileData = ITL::IniLoader("Libs\\Projectiles.ini");
	for(int i = 0; i < ProjectileData.CountGroups(); i++)
	{
		Projectile Proj;
		for(int j = 0; j < ProjectileData.CountKeys(i);j++)
		{
			const char *Key = ProjectileData.GetKey(i, j);
			const char *Value = ProjectileData.GetValue(i, j);
			// Variables
			if(!stricmp(Key, "ID"))
				Proj.ID = atoi(Value);
			// string
			if(!stricmp(Key, "Model"))
			{
				if(*Value)
					sprintf(Proj.Model, "Models\\%s", Value);
				else
					*Proj.Model = 0;
			}
			if(!stricmp(Key, "LaunchSound"))
				sprintf(Proj.LaunchSound, "Sounds\\%s", Value);
			if(!stricmp(Key, "LaunchSpeed"))
				Proj.LaunchSpeed = (float)atof(Value);
			if(!stricmp(Key, "ShotDelay"))
				Proj.ShotDelay = (float)atof(Value);
			if(!stricmp(Key, "HitPFX"))
				Proj.HitPFX = atoi(Value);
			if(!stricmp(Key, "HitPFXNum"))
				Proj.HitPFXNum = atoi(Value);
			if(!stricmp(Key, "HitPFXSpread"))
				Proj.HitPFXSpread = (float)atof(Value);
			if(!stricmp(Key, "HitAmount"))
				Proj.HitAmount = (float)atof(Value);
			if(!stricmp(Key, "GroundHitPFX"))
				Proj.GroundHitPFX = atoi(Value);
			if(!stricmp(Key, "WaterHitPFX"))
				Proj.WaterHitPFX = atoi(Value);
			// int
			if(!stricmp(Key, "TrailPFX"))
				Proj.TrailPFX = atoi(Value);
			if(!stricmp(Key, "Trail"))
				Proj.Trail = !stricmp(Value, "true");
			if(!stricmp(Key, "Split"))
				Proj.Split = !stricmp(Value, "true");
			if(!stricmp(Key, "SplitDist"))
				Proj.SplitDist = (float)atof(Value);
			if(!stricmp(Key, "SplitID"))
				Proj.SplitID = atoi(Value);
			if(!stricmp(Key, "SplitNum"))
				Proj.SplitNum = atoi(Value);
			if(!stricmp(Key, "LaunchPFX"))
				Proj.LaunchPFX = atoi(Value);
			if(!stricmp(Key, "SplitPFX"))
				Proj.SplitPFX = atoi(Value);
			// float
			if(!stricmp(Key, "SplitSpeed"))
				Proj.SplitSpeed = (float)atof(Value);
			// bool
			if(!stricmp(Key, "ShootHigh"))
				Proj.ShootHigh = !stricmp(Value, "true");
			if(!stricmp(Key, "HitFeedback"))
				Proj.HitFeedback = !stricmp(Value, "true");
		}
		Projectiles[Proj.ID] = Proj;
	}
}

}
