/***********************************************************/
/*                                                         */
/* ProjectileLib.h                                         */
/*                                                         */
/* created 04.03.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef PROJECTILELIB_H
#define PROJECTILELIB_H

#include "IniLoader.h"
#include "DynamicArray.h"

// www.infinitecode.com game library
namespace IGAME
{

class ProjectileLib
{
public:
	#define PRJL_STRMEM 1024

	class Projectile
	{
	public:
		Projectile(void): Split(false), Trail(false), SplitSpeed(0), ShootHigh(false), LaunchPFX(0)
			, HitFeedback(true), HitAmount(10), HitPFX(0), GroundHitPFX(0), WaterHitPFX(0), SplitID(0), HitPFXNum(1), SplitNum(20)
			, SplitPFX(0)
		{
			*Model = 0;
			*LaunchSound = 0;
		}

		int ID, HitPFX, GroundHitPFX, WaterHitPFX, TrailPFX, SplitID, HitPFXNum, SplitNum, LaunchPFX, SplitPFX;
		char Model[PRJL_STRMEM], LaunchSound[PRJL_STRMEM];
		float LaunchSpeed, ShotDelay, SplitDist, SplitSpeed, HitPFXSpread, HitAmount;
		bool Trail, Split, ShootHigh, HitFeedback;
	};

	ISL::DynamicArray<Projectile, 0, 1> Projectiles;

	void Create(void);
};

}

#endif
