/***********************************************************/
/*                                                         */
/* RenderableModel.cpp                                     */
/*                                                         */
/* created 20.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "RenderableModel.h"
#include "TextureManager.h"

// www.infinitecode.com 3d library
namespace I3D
{

int RenderableModel::TypeID;

RenderableModel::RenderableModel(void)
:Texture(0), Mdl(0), Data(0), UnLinked(false)
{
	Pos = Vector(0, 0, 0);
	Mtx = new Matrix();
	Mtx->SetIdentityMatrix();
}

void RenderableModel::Create(void *Base)
{
	RenderableModel::Base = Base;
}

void RenderableModel::Render(D3DStruct *DS)
{
	if(Mdl)
	{
		if(Mtx)
			DS->D3DDevice->SetTransform(D3DTS_WORLD, Mtx);
		if(!Texture && *Mdl->GetStandardTexture())
		{
			const char *TxtName = Mdl->GetStandardTexture();
			char *TxtFileName = new char[strlen(TxtName) + 9 + 1];
			strcpy(TxtFileName, "Textures\\");
			strcat(TxtFileName, TxtName);
			Texture = I3D::TextureManager::GetTexture(DS, TxtFileName);
			delete[] TxtFileName;
		}
		DS->D3DDevice->SetTexture(0, Texture);
		Mdl->Render(DS);
	}
}

}
