/***********************************************************/
/*                                                         */
/* SoundManager.h                                          */
/*                                                         */
/* created 09.05.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "SoundManager.h"

// www.infinitecode.com audio library
namespace IAU
{

SoundManager::~SoundManager(void)
{
	Destroy();
}

void SoundManager::Create(HWND Wnd)
{
	SoundManager::Wnd = Wnd;
	DirectSoundCreate8(0, &DSound, 0);
	if(DSound)
		DSound->SetCooperativeLevel(Wnd, DSSCL_NORMAL);
}

void SoundManager::Destroy(void)
{
	// delete all sounds and empty sound list
	Sounds.ClearPtr();
	RELEASE(DSound);
	DSound = 0;
}

LPDIRECTSOUND8 SoundManager::GetDS(void)
{
	return DSound;
}

DSSound *SoundManager::Get(const char *Filename, int MaxInstances)
{
	for(int i = 0; i < Sounds.Count(); i++)
		if(!strcmp(Filename, Sounds[i]->GetFilename()))
			return Sounds[i];
	DSSound *NewSound = new DSSound();
	NewSound->Create(DSound, Filename, MaxInstances);
	Sounds.Add(NewSound);
	return NewSound;
}

}
