/***********************************************************/
/*                                                         */
/* SoundManager.h                                          */
/*                                                         */
/* created 09.05.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef	SOUNDMANAGER_H
#define SOUNDMANAGER_H

#include "DynamicArray.h"
#include "DSSound.h"

#include <dsound.h>
#include <windows.h>

#ifndef RELEASE
	#define RELEASE(x) if(x){(x)->Release();}
#endif

// www.infinitecode.com audio library
namespace IAU
{

class SoundManager
{
	LPDIRECTSOUND8 DSound;
	ISL::DynamicArray<DSSound *> Sounds;
	HWND Wnd;

public:
	SoundManager(void): DSound(0) {}
	~SoundManager(void);

	void Create(HWND Wnd);
	void Destroy(void);

	DSSound *Get(const char *Filename, int MaxInstances = 1);
	LPDIRECTSOUND8 GetDS(void);
};

}

#endif
