/***********************************************************/
/*                                                         */
/* SpaceManagerInterface.h                                 */
/*                                                         */
/* created 18.02.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

// Interface Class for Space Managers like bsptrees, quadtrees
// and octrees

#ifndef SPACEMANAGERINTERFACE_H
#define SPACEMANAGERINTERFACE_H

#include "ManagedObject.h"

// www.infinitecode.com 3d library
namespace I3D
{

class SpaceManagerInterface
{
public:
	virtual void AddManagedObject(ManagedObject *Obj) = 0;
	virtual void DeleteManagedObject(ManagedObject *Obj) = 0;
	virtual void MoveManagedObject(ManagedObject *Obj) = 0;
};

}

#endif
