/***********************************************************/
/*                                                         */
/* TCPSocket.cpp                                           */
/*                                                         */
/* created 08.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "TCPSocket.h"

// www.infinitecode.com Network Library
namespace INETW
{

void TCPSocket::Create(void)
{
#ifdef WIN32
	Sck = socket(AF_INET, SOCK_STREAM, 0);
#else
	Sck = socket(AF_INET, SOCK_STREAM, getprotobyname("tcp")->p_proto);
#endif
}

void TCPSocket::Destroy(void)
{
#ifdef WIN32
	shutdown(Sck, 2);
#else
	shutdown(Sck, SHUT_RDWR);
#endif
}

int TCPSocket::GetSocket()
{
	return Sck;
}

}
