/***********************************************************/
/*                                                         */
/* TCPSocket.h                                             */
/*                                                         */
/* created 07.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TCPSOCKET_H
#define TCPSOCKET_H

#include "PrefixException.h"

#ifdef WIN32
	#include <winsock.h>
#else
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <sys/types.h>
	#include <netdb.h>
//	#include <fcntl.h>
#endif

#include <string.h>
#include <exception>
#include <stdlib.h>

// www.infinitecode.com Network Library
namespace INETW
{

class TCPSocket
{
private:	
	// copying is not allowed
	TCPSocket(TCPSocket&);
	operator=(TCPSocket&);

protected:
	// the constructor is protected, so no instances of this ("abstract") class can be created
	TCPSocket(void)
		:Sck(0)
	{
	}

	// socket handle
	int Sck;
	bool Blocking;

	void Create(void);

public:
	class NetworkException: public IEX::PrefixException
	{
	public:
		NetworkException(char *Description)
			:PrefixException("Network Error: ", Description)
		{
		}
	};

	int GetSocket();
	virtual void Destroy(void);
};

}

#endif
