/***********************************************************/
/*                                                         */
/* Tank4.cpp                                               */
/*                                                         */
/* created 12.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Tank4.h"

#include "Game.h"

#define WIN32_LEAN_AND_MEAN // don't include rarely used header parts
#include <windows.h>
#include <cstdlib>

T4::Game Tank4;

int WINAPI WinMain(HINSTANCE ThisInstance, HINSTANCE PrevInstance, LPSTR Argument, int WindowStyle)
{
	try
	{
		//throw("this is a test error");
		//ITL::MessageWindow::DebugWindow(ThisInstance, "foo", "Unhandled Exception", "Dbg");
		Tank4.Create(WindowStyle);
		bool Quit = false;
		MSG Msg;
		// main message handling loop
		while ( !Quit )
		{
			if ( PeekMessage( &Msg, NULL, 0, 0, PM_REMOVE ) )
			{
				try
				{
					if ( Msg.message == WM_QUIT )
						Quit = true;
					else
					{
						TranslateMessage( &Msg );
						DispatchMessage( &Msg );
					}
				}
				catch(char *s)
				{
					throw s;
				}
				catch(...)
				{
					throw("exception in WinMain#Message Loop");
				}
			}
			else
			{
				try
				{
					// Game main loop function
					Tank4.MainLoop();
				}
				catch(char *s)
				{
					throw s;
				}
				catch(...)
				{
					throw("exception in WinMain() when calling MainLoop");
				}
			}
		}
	}
	catch(exception& Ex)
	{
		// exceptions
		char Str[1024];
		std::sprintf(Str, "Unhandled Exception: %s", (char *)Ex.what());
		ITL::LogFile::Msg("Error.txt", Str);
		//ITL::MessageWindow::Message(Str, "Unhandled Exception");
		Tank4.SetFullscreen(false);
		ITL::MessageWindow::DebugWindow(ThisInstance, Tank4.GetHWnd(), Str, "Unhandled Exception", Tank4.DebugInfo());
		return -1;
	}
	catch(char *Ex)
	{
		// char * exceptions
		char Str[1024];
		sprintf(Str, "Unhandled Exception (char *): %s", Ex);
		ITL::LogFile::Msg("Error.txt", Str);
		//ITL::MessageWindow::Message(Str, "Unhandled Exception");
		Tank4.SetFullscreen(false);
		ITL::MessageWindow::DebugWindow(ThisInstance, Tank4.GetHWnd(), Str, "Unhandled Exception", Tank4.DebugInfo());
		return -1;
	}
	catch(int Ex)
	{
		// int exceptions
		char Str[1024];
		sprintf(Str, "Unhandled Exception (int): %d", Ex);
		ITL::LogFile::Msg("Error.txt", Str);
		//ITL::MessageWindow::Message(Str, "Unhandled Exception");
		Tank4.SetFullscreen(false);
		ITL::MessageWindow::DebugWindow(ThisInstance, Tank4.GetHWnd(), Str, "Unhandled Exception", Tank4.DebugInfo());
		return -1;
	}
	catch(...)
	{
		// unknown exceptions
		char Str[1024];
		sprintf(Str, "Unknown Unhandled Exception");
		ITL::LogFile::Msg("Error.txt", Str);
		//ITL::MessageWindow::Message(Str, "Unhandled Exception");
		Tank4.SetFullscreen(false);
		ITL::MessageWindow::DebugWindow(ThisInstance, Tank4.GetHWnd(), Str, "Unhandled Exception", Tank4.DebugInfo());
		return -1;
	}
	return 0;
}
