/***********************************************************/
/*                                                         */
/* TerrainDsc.h                                            */
/*                                                         */
/* created 28.04.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TERRAINDSC_H
#define TERRAINDSC_H

#include "MathStructures.h"
#include "IDTerrain.h"

// www.infinitecode.com 3d library
namespace I3D
{

	class TerrainDsc
	{
	public:
		struct TerrainDscSpecs
		{
			int ID;
			IMATH::Vector2DXZ Pos[3];
			char Name[1024];
		} Specs;

		TerrainDsc(void) {}

		const IMATH::Vector2DXZ &GetPos(int Index) const
		{
			return Specs.Pos[Index];
		}

		void SetPos(int Index, const IMATH::Vector2DXZ &Pos)
		{
			Specs.Pos[Index] = Pos;
		}

		const char *GetName() const
		{
			return Specs.Name;
		}

		const IMATH::Vector2DXZ *GetTriangle() const
		{
			return Specs.Pos;
		}

		TerrainDsc(TerrainDscSpecs *Specs)
		{
			TerrainDsc::Specs = *Specs;
		}
	};

}

#endif
