/***********************************************************/
/*                                                         */
/* TerrainInterface.h                                      */
/*                                                         */
/* created 14.04.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TERRAININTERFACE_H
#define TERRAININTERFACE_H

#include "MathStructures.h"

// www.infinitecode.com 3d interface
namespace I3D
{

class TerrainInterface
{
public:
	virtual float GetY(float x, float z) const = 0;
	virtual int GetResX(void) = 0;
	virtual int GetResZ(void) = 0;
	virtual IMATH::Vector GetNormal(float x, float z) const = 0;
	virtual float GetAcc(float x, float z) const = 0; // accessibility (f'(x, z))
	virtual float GetAccNormed(float x, float z) const = 0; // [0.0f...1.0f]
	virtual int GetAccResX(void) = 0;
	virtual int GetAccResZ(void) = 0;
	virtual float GetSize(void) = 0;
	virtual bool GetWater(int x, int z) = 0;
};

}

#endif


