/***********************************************************/
/*                                                         */
/* TerrainLine.h                                           */
/*                                                         */
/* created 14.04.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TERRAINLINE_H
#define TERRAINLINE_H

#include "TerrainInterface.h"
#include "TerrainLineRenderer.h"
#include "D3DStruct.h"
#include "RenderStruct.h"

// www.infinitecode.com 3d library
namespace I3D
{

class TerrainLine
{
public:
	class TerrainLineSpecs
	{
	public:
		TerrainInterface *TI;
		TerrainLineRenderer *TLR;
		IMATH::Vector2DXZ Pos[2];
		D3DStruct *DS;
		unsigned int Color;
		float Width;

		TerrainLineSpecs(void);
	};

private:
	TerrainLineSpecs Specs;
	bool used;
	RenderStruct<LVertex, I3D_FVFLVERTEX, 4, 1> RS;

	TerrainLine(const TerrainLine &TL) {}

public:
	TerrainLine(void);
	~TerrainLine(void);

	TerrainLine &operator=(const TerrainLine &TL)
	{
		Create(&TL.Specs);
		return *this;
	}

	void Create(const TerrainLineSpecs *TLS);
	void Destroy(void);
	void Render(D3DStruct *DS);
	void Init3D(D3DStruct *DS, bool recurse);
	void UnLink(void);
};

}

#endif
