/***********************************************************/
/*                                                         */
/* TerrainLineRenderer.h                                   */
/*                                                         */
/* created 14.04.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TERRAINLINERENDERER_H
#define TERRAINLINERENDERER_H

#include "D3DStruct.h"

// www.infinitecode.com 3d interface
namespace I3D
{

class TerrainLine;

class TerrainLineRenderer
{
	ISL::DynamicArray<TerrainLine *> Lines;

public:
	~TerrainLineRenderer(void);

	void Create(D3DStruct *DS);
	void Init3D(D3DStruct *DS, bool recurse);
	void Destroy(void);

	void Add(TerrainLine *TL);
	void Delete(TerrainLine *TL);
	void Render(D3DStruct *DS);
};

}

#endif
