/***********************************************************/
/*                                                         */
/* TextField.h                                             */
/*                                                         */
/* created 08.03.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TEXTFIELD_H
#define TEXTFIELD_H

#include "D3DStruct.h"
#include "RenderStruct.h"
#include "TextureManager.h"

#include <sstream>

#include <d3d9.h>

// www.infinitecode.com 3d library
namespace I3D
{

class TextField
{

	#define TXTF_STRMEM 1024

	static LPDIRECT3DTEXTURE9 Background;
	RenderStruct<Vertex, I3D_FVFVERTEX, 1, 1> RS;
	//std::ostringstream Text;
	std::string TextString;

public:
	TextField(void) {}

	template<typename type>
	TextField& operator << (type Var)
	{
		//Text << Var;
		TextString += Var;
		/*const char *Str = os.str().c_str();
		strncat(Text, Str, min(strlen(Str), TXTF_STRMEM - strlen(Text) - 1));*/
		return *this;
	}

	void Create(D3DStruct *DS);
	void Render(D3DStruct *DS, float x, float y, float dx, float dy);
	void Init3D(D3DStruct *DS, bool recurse);
	void Clear();
};

}

#endif
