/***********************************************************/
/*                                                         */
/* WaterPlane.h                                            */
/*                                                         */
/* created 16.06.2003                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef WATERPLANE_H
#define WATERPLANE_H

#include "Renderable.h"
#include "D3DStruct.h"
#include "DataStructures.h"

#include <d3d9.h>

// www.infinitecode.com 3d library
namespace I3D
{

class WaterPlane: public Renderable
{
	BoundingBox BBox;
	float WaterLevel;
	LPDIRECT3DTEXTURE9 Tex, Bump, Env;
	bool Visible;

	RenderStruct<LVertex, I3D_FVFLVERTEX, 64, 64> RS;
	LVertex Vertices[4];
	static unsigned *PShader;

public:
	void Create(D3DStruct *DS, BoundingBox *BBox, float WaterLevel);
	void Init3D(D3DStruct *DS, bool recurse);

	void SetVisible(bool Value)
	{
		Visible = Value;
	}

	bool GetVisible()
	{
		return Visible;
	}

	void CreateView(D3DStruct *DS);
	void Render(D3DStruct *DS);
};

}

#endif
